create or replace
PROCEDURE CCH_IMPORTA_FILIAL_SAP
IS
   V_CDPAIS       INTEGER;
   V_SGESTADO     INTEGER;
   V_CDFILIAL     INTEGER;
   V_PAISC        INTEGER;
   V_ESTADOC      INTEGER;
   V_CDMUNICIPIO  VARCHAR2(7);
   V_CDMUNICIPIOC VARCHAR2(7);
   V_ENDEFILIC    INTEGER;
   V_INSCRMUNI    INTEGER;
   V_CDSERIE      VARCHAR2(10);
   V_EXISTSERIE   INTEGER;
   V_NMRAZSOCEMPR VARCHAR(80);
   V_IDENTRSAID   VARCHAR2(1);
   V_CDTIPOOPER   VARCHAR2(2);
   V_ERROR        VARCHAR2(300);
   V_CDINSCESTA   VARCHAR2(16);

BEGIN
   FOR C_FILIAL IN
       (SELECT U.CDFILIAL, U.NMFILIAL, P.CDEMPRESA, U.CDEMPINTEGRACAO, U.CDINSCESTA, U.CDINSCMUNI, U.DSENDERECOP, U.CDPAISP, U.SGESTADOP, SUBSTR(U.CDMUNICIPIOP, 3, 5) AS CDMUNICIPIOP,
               U.CDCEPP, U.NMBAIRROP, U.EMAIL, U.DSENDERECOC, U.CDPAISC, U.SGESTADOC, SUBSTR(U.CDMUNICIPIOC, 3, 5) AS CDMUNICIPIOC, U.CDCEPC, U.NMBAIRROC, U.NMRAZSOCFILI,
               U.CELOG, U.CECO,
               U.NRINSJURFILI, U.IDINTERFACE, U.TPINTERFACE
          FROM USR_SAP_FILIAL U, PARAMEMPRESA P
         WHERE U.CDEMPINTEGRACAO = P.CDEMPINTEGRACAO
           AND U.DTINTERFACEDEST IS NULL
         ORDER BY U.DTINTERFACEORI)
   LOOP
      SELECT COUNT(1) AS CDPAIS
        INTO V_CDPAIS
        FROM PAIS
       WHERE CDPAIS = C_FILIAL.CDPAISP;

      V_CDINSCESTA := NULL;
       
      SELECT MIN(CDINSCESTA)
        INTO V_CDINSCESTA
        FROM INSCRESTAD
       WHERE CDEMPRESA = C_FILIAL.CDEMPRESA;

      IF V_CDPAIS > 0 THEN
         SELECT COUNT(1) AS SGESTADO
           INTO V_SGESTADO
           FROM ESTADO
          WHERE CDPAIS   = C_FILIAL.CDPAISP
            AND SGESTADO = C_FILIAL.SGESTADOP;

         IF V_SGESTADO > 0 THEN
            BEGIN
               SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                 INTO V_CDMUNICIPIO
                 FROM MUNICIPIO
                WHERE CDPAIS     = C_FILIAL.CDPAISP
                  AND SGESTADO   = C_FILIAL.SGESTADOP
                  AND CDMUNIEXPO = C_FILIAL.CDMUNICIPIOP;

               IF V_CDMUNICIPIO IS NOT NULL THEN
                  BEGIN
                     SELECT MIN(I.CDINSCMUNI), MIN(SUBSTR(NMRAZSOCEMPR, 1, 40))
                       INTO V_INSCRMUNI, V_NMRAZSOCEMPR
                       FROM INSCRMUNICIP I, EMPRESA E
                      WHERE E.CDEMPRESA = C_FILIAL.CDEMPRESA
                        AND I.CDEMPRESA  = E.CDEMPRESA;
                  EXCEPTION
                     WHEN OTHERS THEN
                        V_INSCRMUNI := NULL; V_NMRAZSOCEMPR := NULL;
                  END;

               IF V_INSCRMUNI IS NULL THEN
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'A inscripcin ' ||C_FILIAL.CDINSCMUNI||' no relacionado con la empresa. '|| C_FILIAL.CDEMPINTEGRACAO);

                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
               ELSE
                  SELECT COUNT(1) AS CDFILIAL
                    INTO V_CDFILIAL
                    FROM FILIAL
                   WHERE CDFILIAL = C_FILIAL.CDFILIAL;

                  IF V_CDFILIAL = 0 THEN
                     INSERT INTO CENTCUST
                        (CDCENTCUST, NMCENTCUST)
                     VALUES
                        (C_FILIAL.CELOG, C_FILIAL.NMFILIAL);
                     /* Filial */
                     INSERT INTO FILIAL
                        (CDFILIAL, NMFILIAL, CDEMPRESA, CDINSCESTA, CDINSCMUNI,
                         IDTPIJURFILI, NRINSJURFILI, NMRAZSOCFILI, CDCENTCUST)
                     VALUES
                        (C_FILIAL.CDFILIAL, C_FILIAL.NMFILIAL, C_FILIAL.CDEMPRESA, V_CDINSCESTA, V_INSCRMUNI,
                         'I', C_FILIAL.NRINSJURFILI, C_FILIAL.NMRAZSOCFILI, C_FILIAL.CELOG);

                     /* Endereo principal */
                     INSERT INTO ENDEFILI
                        (CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI,
                         NMBAIRFILI, DSEMAILFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                     VALUES
                        (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOP, C_FILIAL.CDPAISP, C_FILIAL.SGESTADOP, V_CDMUNICIPIO, C_FILIAL.CDCEPP,
                         C_FILIAL.NMBAIRROP, C_FILIAL.EMAIL, 'P', 'N', 'N');

                     /* Endereo entrega */
                     INSERT INTO ENDEFILI
                        (CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI,
                         NMBAIRFILI, DSEMAILFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                     VALUES
                        (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOP, C_FILIAL.CDPAISP, C_FILIAL.SGESTADOP, V_CDMUNICIPIO, C_FILIAL.CDCEPP,
                         C_FILIAL.NMBAIRROP, C_FILIAL.EMAIL, 'T', 'N', 'N');

                     INSERT INTO PARAMFILIAL
                        (CDFILIAL, IDCTRLESTQ, CDEXFILIAL)
                     VALUES
                        (C_FILIAL.CDFILIAL, 'N', C_FILIAL.CECO);

                     INSERT INTO ALMOXARIFADO
                       (CDFILIAL, CDALMOXARIFE, DSALMOXARIFE)
                       (SELECT C_FILIAL.CDFILIAL, ' ', ' '
                          FROM PARAMGERAL
                         MINUS
                        SELECT CDFILIAL, CDALMOXARIFE, DSALMOXARIFE
                          FROM ALMOXARIFADO
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL
                           AND CDALMOXARIFE = ' ');

                     INSERT INTO PARAMFILIPADR
                        (CDFILIAL, NMTABPARAMFILI)
                        (SELECT C_FILIAL.CDFILIAL, NMTABPARAMFILI
                           FROM (SELECT 'ALMOXARIFADO' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'LOCALESTOQUE' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'PARAMFILIAL' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'PARAMPEDIDO' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'PARAMPLANEJA' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'PARCMPSUP' AS NMTABPARAMFILI
                                   FROM DUAL
                                  UNION
                                 SELECT 'PAREXPEDICAO' AS NMTABPARAMFILI
                                   FROM DUAL
                                ) A
                          WHERE NOT EXISTS(SELECT 1
                                             FROM PARAMFILIPADR PF
                                            WHERE PF.CDFILIAL       = C_FILIAL.CDFILIAL
                                              AND PF.NMTABPARAMFILI = A.NMTABPARAMFILI));

                     /* LOG */
                     INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                     VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 0, 'Unidad '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||' registrada con xito.');

                     /* Atualiza registro pra no ser importado de novo  */
                     UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                      WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;

                     /* Endereo de cobrana  */
                     SELECT COUNT(1) AS CDPAIS
                       INTO V_PAISC
                       FROM PAIS
                      WHERE CDPAIS = C_FILIAL.CDPAISC;

                     IF V_PAISC > 0 THEN
                        SELECT COUNT(1) AS SGESTADO
                          INTO V_ESTADOC
                          FROM ESTADO
                         WHERE CDPAIS   = C_FILIAL.CDPAISC
                           AND SGESTADO = C_FILIAL.SGESTADOC;

                        IF V_ESTADOC > 0 THEN
                           BEGIN
                              SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                                INTO V_CDMUNICIPIOC
                                FROM MUNICIPIO
                               WHERE CDPAIS     = C_FILIAL.CDPAISC
                                 AND SGESTADO   = C_FILIAL.SGESTADOC
                                 AND CDMUNIEXPO = C_FILIAL.CDMUNICIPIOC;

                              IF V_CDMUNICIPIOC IS NOT NULL THEN
                                 INSERT INTO ENDEFILI
                                    (CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI,
                                     NMBAIRFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                                 VALUES
                                    (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOC, C_FILIAL.CDPAISC, C_FILIAL.SGESTADOC, V_CDMUNICIPIOC, C_FILIAL.CDCEPC,
                                     C_FILIAL.NMBAIRROC, 'C', 'N', 'N');
                              ELSE
                                 V_CDMUNICIPIOC := '';
                                 INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FILIAL.CDMUNICIPIOC ||', relacionado a coleccin de la unidad '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', no registrado en el sistema Teknisa.');

                                 /* Atualiza registro pra que o mesmo possa ser importado aps correo.  */
                                 UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                  WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
                              END IF;
                           EXCEPTION
                              WHEN NO_DATA_FOUND THEN
                                 V_CDMUNICIPIOC := '';

                                 INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                 VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FILIAL.CDMUNICIPIOC ||', relacionado a coleccin de la unidad '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', no registrado en el sistema Teknisa.');

                                 /* Atualiza registro pra que o mesmo possa ser importado aps correo.  */
                                 UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                  WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
                           END;
                        END IF;
                     END IF;
                  ELSE
                     BEGIN
                        SELECT NVL(CDSERIE, '0000000000')
                          INTO V_CDSERIE
                          FROM FILIAL
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL;
                     EXCEPTION
                        WHEN OTHERS THEN
                           V_CDSERIE := '0000000000';
                     END;

                     IF V_CDSERIE != '0000000000' THEN
                        SELECT COUNT(1)
                          INTO V_EXISTSERIE
                          FROM SERIENF
                         WHERE CDEMPRESA  = C_FILIAL.CDEMPRESA
                           AND CDINSCMUNI = V_INSCRMUNI
                           AND CDINSCESTA = V_CDINSCESTA
                           AND CDSERIE    = V_CDSERIE;
                     ELSE
                        V_EXISTSERIE := 1;
                     END IF;

                     IF V_EXISTSERIE > 0 THEN
                        UPDATE FILIAL
                           SET NMFILIAL = C_FILIAL.NMFILIAL,
                               NRINSJURFILI = C_FILIAL.NRINSJURFILI,
                               CDEMPRESA = C_FILIAL.CDEMPRESA,
                               CDINSCESTA = V_CDINSCESTA,
                               CDINSCMUNI = V_INSCRMUNI,
                               NMRAZSOCFILI = V_NMRAZSOCEMPR,
                               CDCENTCUST = C_FILIAL.CELOG
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL;

                        UPDATE ENDEFILI SET DSENDEFILI = C_FILIAL.DSENDERECOP, CDPAIS = C_FILIAL.CDPAISP, SGESTADO = C_FILIAL.SGESTADOP,
                                            CDMUNICIPIO = V_CDMUNICIPIO, NRCEPFILI = C_FILIAL.CDCEPP, NMBAIRFILI = C_FILIAL.NMBAIRROP,
                                            DSEMAILFILI = C_FILIAL.EMAIL
                         WHERE CDFILIAL = C_FILIAL.CDFILIAL
                           AND IDTPENDEFILI = 'P';

                        SELECT COUNT(1) AS CDPAIS
                          INTO V_PAISC
                          FROM PAIS
                         WHERE CDPAIS = C_FILIAL.CDPAISC;

                        IF V_PAISC > 0 THEN
                           SELECT COUNT(1) AS SGESTADO
                             INTO V_ESTADOC
                             FROM ESTADO
                            WHERE CDPAIS   = C_FILIAL.CDPAISC
                              AND SGESTADO = C_FILIAL.SGESTADOC;

                           IF V_ESTADOC > 0 THEN
                              BEGIN
                                 SELECT MAX(CDMUNICIPIO) CDMUNICIPIO
                                   INTO V_CDMUNICIPIOC
                                   FROM MUNICIPIO
                                  WHERE CDPAIS     = C_FILIAL.CDPAISC
                                    AND SGESTADO   = C_FILIAL.SGESTADOC
                                    AND CDMUNIEXPO = C_FILIAL.CDMUNICIPIOC;

                                 IF V_CDMUNICIPIOC IS NOT NULL THEN
                                    SELECT COUNT(1)
                                      INTO V_ENDEFILIC
                                      FROM ENDEFILI
                                     WHERE CDFILIAL = C_FILIAL.CDFILIAL
                                       AND IDTPENDEFILI = 'C';

                                    IF V_ENDEFILIC > 0 THEN
                                       UPDATE ENDEFILI SET DSENDEFILI = C_FILIAL.DSENDERECOC, CDPAIS = C_FILIAL.CDPAISC, SGESTADO = C_FILIAL.SGESTADOC,
                                                           CDMUNICIPIO = V_CDMUNICIPIOC, NRCEPFILI = C_FILIAL.CDCEPC, NMBAIRFILI = C_FILIAL.NMBAIRROC,
                                                           DSEMAILFILI = C_FILIAL.EMAIL
                                        WHERE CDFILIAL = C_FILIAL.CDFILIAL
                                          AND IDTPENDEFILI = 'C';
                                    ELSE
                                       INSERT INTO ENDEFILI(CDFILIAL, DSENDEFILI, CDPAIS, SGESTADO, CDMUNICIPIO, NRCEPFILI,
                                                            NMBAIRFILI, IDTPENDEFILI, IDUTTLSEMAIL, IDUTSSLEMAIL)
                                       VALUES (C_FILIAL.CDFILIAL, C_FILIAL.DSENDERECOC, C_FILIAL.CDPAISC, C_FILIAL.SGESTADOC, V_CDMUNICIPIOC, C_FILIAL.CDCEPC,
                                               C_FILIAL.NMBAIRROC, 'C', 'N', 'N');
                                    END IF;

                                    UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                                     WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                                 END IF;
                              EXCEPTION
                                 WHEN NO_DATA_FOUND THEN
                                    V_CDMUNICIPIOC := '';
                                    INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                                    VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FILIAL.CDMUNICIPIOC ||', relacionado a coleccin de la unidad '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', no registrado en el sistema Teknisa.');

                                    UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                                     WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                              END;
                           END IF;
                        END IF;

                        INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES (C_FILIAL.IDINTERFACE, 'A', 3, SYSDATE, 0, 'La actualizacin de la unidad se complet con xito.');

                        UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = SYSDATE, STATUS = 0
                         WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                     ELSE
                        INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                        VALUES (C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'No se puede actualizar de la unidad '|| C_FILIAL.CDFILIAL ||', ya que la serie no est vinculada al inscripcin');

                        UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                         WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
                     END IF;
                  END IF;
               END IF;
               ELSE
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FILIAL.CDMUNICIPIOP ||', relacionado a direcin de la unidad principal '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', no registrado en el sistema Teknisa.');

                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
               END IF;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDMUNICIPIO := '';
                  INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
                  VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo de exportacin '||C_FILIAL.CDMUNICIPIOP ||', relacionado a direcin de la unidad principal '|| C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||', no registrado en el sistema Teknisa.');
                  
                  UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
                   WHERE IDINTERFACE = C_FILIAL.IDINTERFACE;
            END;
         ELSE
            INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
            VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'Sigla de el estado '|| C_FILIAL.SGESTADOP || ',relacionado a la unidad '  || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL || ', no registrado en el sistema Teknisa.');

            UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
             WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;

         END IF;
      ELSE
         INSERT INTO USR_SAP_LOG(IDINTERFACE, IDSEQLOG, IDPROCESSO, DTLOG, STATUS, OBSSTATUS)
         VALUES(C_FILIAL.IDINTERFACE, 'I', 3, SYSDATE, 1, 'C'||CHR(243)||'digo do pa'||CHR(237)||'s '||C_FILIAL.CDPAISP || ',relacionado a la unidad '  || C_FILIAL.CDFILIAL || ' - ' || C_FILIAL.NMFILIAL ||  ', no registrado en el sistema Teknisa.');

         UPDATE USR_SAP_FILIAL SET DTINTERFACEDEST = NULL, STATUS = 2
          WHERE IDINTERFACE    = C_FILIAL.IDINTERFACE;
      END IF;
   END LOOP;
   COMMIT;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('CCH_IMPORTA_FILIAL_SAP','6.49.044'); END;
/
